/*******************************************************************
 *
 *	File:		CConsoleController.h
 *
 *	Author:		Peter van Sebille (peter@yipton.demon.co.uk)
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __CARLO_CONTROLLER_H
#define __CARLO_CONTROLLER_H

class RArLo;
class CArloBase;
class CConsoleEditor;
class CArloConfig;
class TArloBootItem;
class RWsSession;

class CArloController : public CBase
{
public:
	~CArloController();
	static CArloController* NewLC(CConsoleBase& aConsole, RArLo& aArloDevice, RFs& aFs, RWsSession& aWsSession);
	void DoTheArloThingL(TBool aRunsAsBootLoader);


protected:
	CArloController(CConsoleBase& aConsole, RFs& aFs, RWsSession& aWsSession) : iConsole(aConsole), iFs(aFs), iWsSession(aWsSession){}
	void ConstructL(RArLo& aArloDevice);

	TBool	GetNumber(TLex& aLex, TUint32& aNumber);

	void	DisplayBootMenuL(TBool aAdvanced);
	TBool	WaitForInput(TChar& aChar, TInt aTimeout);
	void	BootLinuxL(const TArloBootItem& aArloBootItem);
	void	BootLinux(const TArloBootItem& aArloBootItem);
	TBool	DoExpertArloThingL();
	void	LoadFileL(const TDesC& aFileName);
	void	LoadFile(const TDesC& aFileName);
	void	SetBootOptions(const TDesC& aBootOptions);

	void	ArloVirtualToPhysical(TUint32 aVirtualAddress);
	TUint	ArloExamine(TUint32 aAddressToExamine);
	void	DetectRam();
	void	FindMappedAreas();

	void	HardwareProbe(TUint aAddress);

	void	CopyFileL(TDesC& aFileName);
	void	ArloCopyFile(TDesC& aFileName);

	void	DisplayInformationL();
	void	DisplayMemoryInformationL();
	void	DisplayVideoInformationL();
	void	DisplayMachineInformationL();
	void	PrintExpertMenu();

	TBool	BootStrap(const TArloBootItem& aArloBootItem, TBool aRunsAsBootLoader);
	TBool	StartAppL(const TDesC& aEpocApplication);


protected:
	CArloConfig*		iArloConfig;
	CConsoleBase&		iConsole;
	CArloBase*			iArlo;
	CConsoleEditor*		iCommandLine;
	RFs&				iFs;
	RWsSession&			iWsSession;
};



#endif			/* __CARLO_CONTROLLER_H */
