/*******************************************************************
 *
 *	File:		RArlo.h
 *
 *	Author:		Peter van Sebille (peter@yipton.demon.co.uk)
 *				Based on code from Otfried Cheong
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __ARLO_H__
#define __ARLO_H__

#include "..\ldd\arlo.h"

class RArLo : public RLogicalChannel
{
public:
	TInt Open(const TVersion& aVer)
	{
		return DoCreate(KArloDriverName, aVer, NULL, KNullUnit, NULL, NULL);
	}
	
	TVersion VersionRequired() const {return TVersion(0, 0, 0);}

	TInt ExamineS5(TUint32 *anAddr){return DoControl(KArloLddExamineS5, ((TAny *) anAddr));}
	TInt ExamineArm4(TUint32 *anAddr){return DoControl(KArloLddExamineArm4, ((TAny *) anAddr));}

	TInt BootS5(TUint32 aPhysMapAdr, TUint32 aBootAdr){return DoControl(KArloLddBootS5, ((TAny *) aPhysMapAdr), ((TAny *) aBootAdr));}
	TInt BootOrigS5mx(TUint32 aPhysMapAdr, TUint32 aBootAdr){return DoControl(KArloLddBootS5, ((TAny *) aPhysMapAdr), ((TAny *) aBootAdr));}
	TInt BootS5mx(TUint32 aPhysMapAdr, TUint32 aBootAdr){return DoControl(KArloLddBootS5mx, ((TAny *) aPhysMapAdr), ((TAny *) aBootAdr));}
	TInt BootS7(TUint32 aPhysMapAdr, TUint32 aBootAdr){return DoControl(KArloLddBootS7, ((TAny *) aPhysMapAdr), ((TAny *) aBootAdr));}

	TInt GetProcessorId(TUint* aProcId){return DoControl(KArloLddProcId, ((TAny *) aProcId));}
};

#endif
